<script lang="ts">
	import Map from '$lib/Map/Map.svelte';
	import { userMetaData } from '$lib/userStore';
	import Drawer, { Content, Header, Scrim, Subtitle, Title } from '@smui/drawer';
	import Fab, { Icon, Label } from '@smui/fab';
	import IconButton from '@smui/icon-button';
	import { Item } from '@smui/list';
	import Menu from '@smui/menu';
	import Paper from '@smui/paper';

	import Avatar from '$lib/Avatar.svelte';
	import { featureToggles } from '$lib/featureToggles';
	import ScheduleDrawer from '$lib/Schedule/ScheduleDrawer.svelte';
	import PeopleDrawer from '$lib/People/PeopleDrawer.svelte';
	import type { PageData } from './$types';
	export let data: PageData;

	let peopleOpen = false;
	let logoutMenu: Menu;
	let scheduleOpen = false;

	let geolocate: () => void;

	export let tryHighlightRoom: ((room: string) => boolean) | undefined = undefined;

	const onClickScheduleEvent = (location: string) => {
		if (tryHighlightRoom?.call(undefined, location)) {
			scheduleOpen = false;
		}
	};
</script>

<div class="bottomDrawerContainer">
	<PeopleDrawer bind:open={peopleOpen} />
	<ScheduleDrawer bind:open={scheduleOpen} bind:schedule={data.schedule} {onClickScheduleEvent} />

	<Scrim />
</div>
<div id="container">
	<div id="map-container">
		<Map bind:geolocate bind:tryHighlightRoom />
		<div id="fabControls">
			<Fab aria-label="Geolocate" on:click={geolocate} color="secondary"
				><Icon class="material-icons">my_location</Icon></Fab
			>
			{#if $featureToggles['enable-ping']}
				<Fab color="primary"><Icon class="material-icons">share_location</Icon></Fab>
			{/if}
			{#if $featureToggles['enable-mood']}
				<Fab color="primary"><Icon class="material-icons">mood</Icon></Fab>
			{/if}
		</div>
		<div id="topControls">
			{#if $featureToggles['enable-user-management']}
				{#if $userMetaData.status === 'not_logged_in'}
					<Fab color="secondary" href="/auth" extended
						><Icon class="material-icons">person</Icon><Label>Not logged in</Label></Fab
					>
				{:else}
					<Fab name="usermenu" color="primary" extended on:click={() => logoutMenu.setOpen(true)}>
						{#if $userMetaData.user.avatar_url}
							<Avatar src={$userMetaData.user.avatar_url} />
						{:else}
							<Icon class="material-icons">person</Icon>
						{/if}
						<Label>{$userMetaData.user.preferred_username}</Label></Fab
					>
					<Menu bind:this={logoutMenu} anchorCorner="BOTTOM_START">
						<Item
							on:click={async () => {
								await fetch('/auth/signout', { method: 'POST' });
								location.reload();
							}}>Logout</Item
						>
					</Menu>
				{/if}
			{/if}
		</div>
	</div>
	{#if $featureToggles['enable-people'] || $featureToggles['enable-schedule']}
		<Paper elevation={10} square={true} style="z-index: 1; padding: 16px"
			><div class="bottomNav">
				<div class="bottomNavItem">
					{#if $featureToggles['enable-people']}
						<IconButton on:click={() => (peopleOpen = true)} class="material-icons"
							>people</IconButton
						>
						<b><small>People</small></b>
					{/if}
				</div>
				<div class="bottomNavItem">
					{#if $featureToggles['enable-schedule']}
						<IconButton
							on:click={() => (scheduleOpen = true)}
							aria-label="Schedule"
							role="button"
							class="material-icons">calendar_today</IconButton
						>
						<b><small>Schedule</small></b>
					{/if}
				</div>
			</div>
		</Paper>
	{/if}
</div>

<style lang="scss">
	:global(.bottomDrawer) {
		width: 100vw;
		height: auto;
		max-height: 75vh;
		bottom: 0;
	}
	:global(.bottomDrawerContainer .mdc-drawer--animate) {
		transform: translateY(100%);
	}

	:global(.bottomDrawerContainer .mdc-drawer--opening) {
		transform: translateY(0);
	}

	:global(.bottomDrawerContainer .mdc-drawer--closing) {
		transform: translateY(100%);
	}
	#map-container {
		flex-grow: 1;
		position: relative;
	}
	#fabControls {
		position: absolute;
		bottom: 32px;
		right: 16px;
		display: flex;
		flex-direction: column;
		gap: 16px;
	}
	#topControls {
		position: absolute;
		top: 16px;
		right: 16px;
		display: flex;
		flex-direction: column;
		gap: 16px;
	}
	#container {
		width: 100vw;
		height: 100%;
		display: flex;
		flex-direction: column;
		:global(.mdc-snackbar) {
			padding-bottom: var(--mdc-snackbar-offset);
		}
	}
	.bottomNav {
		display: flex;
		justify-content: space-evenly;
		align-items: center;
	}

	.bottomNavItem {
		flex-grow: 1;
		display: flex;
		flex-direction: column;
		justify-content: center;
		align-items: center;
		gap: 4px;
		position: relative;

		&:before {
			content: '';
			border: 1px solid #e0e0e0;
			position: absolute;
			right: -2px;
			height: 100%;
		}
		&:last-child:before {
			display: none;
		}

		:global(.mdc-icon-button__ripple) {
			&::before {
				opacity: 0.04;
			}
		}
		:global(.mdc-icon-button) {
			&:hover {
				:global(.mdc-icon-button__ripple) {
					&::before {
						opacity: 0.1;
					}
				}
			}
		}
	}
</style>
